#include <KD/kd.h>
#include <SLES/OpenSLES.h>
#include <ogg/ogg.h>
#include <Tremor/ivorbiscodec.h>
#include <Tremor/ivorbisfile.h>

// Đobt@TCY
static const int BUFFER_LENGTH = 128 * 1024;

// Đobt@̕
static const int BUFFER_BLOCK_COUNT = 4;

/**
 * @brief R[obNReLXg
 *
 * ĐL[̃R[obNɕKvȃf[^ێ
 */
typedef struct 
{
	// Đobt@
	char* buffer;

	// ɎgpĐubN
	int nextBlock;

	// Ogg vorbist@C
	OggVorbis_File oggVorbisFile;
} CallbackContext;

/**
 * @brief Đobt@Ƀf[^[UčĐL[ɃZbg
 *
 * @param bufferQueueInterface ĐL[C^[tF[X
 * @param context R[obNReLXg
 */
bool enqueue(SLBufferQueueItf bufferQueueInterface, CallbackContext* context)
{
	// ǂݍރf[^TCY
	int length = BUFFER_LENGTH / BUFFER_BLOCK_COUNT;

	// ǂݍ݈ʒu
	char* buffer = &context->buffer[length * context->nextBlock];

	// ̃obt@Ƀf[^[U
	for (int read = 0; read < length;)
	{
		// ǂݍ
		int r =  ov_read(&context->oggVorbisFile, buffer + read,  length - read, 0);

		// t@CI[ɒBĂ擪ֈړ
		if (r == 0)
			ov_time_seek(&context->oggVorbisFile, 0);
		// łȂ΃f[R[hꂽTCYXV
		else
			read += r;

	}

	// obt@ĐL[ɃZbg
	SLresult result = (*bufferQueueInterface)->Enqueue(bufferQueueInterface, buffer, length);
	if(result != SL_RESULT_SUCCESS)
	{
		kdLogMessage("BufferQueue Enqueue() failed");
		return false;
	}

	// ɎgpubN
	if (++context->nextBlock >= BUFFER_BLOCK_COUNT)
		context->nextBlock = 0;

	return true;
}

/**
 * @brief obt@̍ĐJnꂽɃR[obN
 *
 * ĐL[ɓꂽobt@P閈ɌĂ΂ƎvĐJnɌĂ΂
 * ĐL[ɓobt@͂߂^C~OŌĂ΂悤
 *
 * @param bufferQueueInterface ĐL[C^[tF[X
 * @param context R[obNReLXg
 */
static
void bufferQueueCallback(SLBufferQueueItf bufferQueueInterface, void* context)
{
	enqueue(bufferQueueInterface, reinterpret_cast<CallbackContext*>(context));
}

/**
 * @brief vÕGg|Cg
 */
KDint kdMain(KDint argc, const KDchar *const *argv)
{
	SLresult result;

	// TEhGWIuWFNg̍쐬
	SLObjectItf engineObject;
	result = slCreateEngine(&engineObject, 0, KD_NULL, 0, KD_NULL, KD_NULL);
	if(result != SL_RESULT_SUCCESS)
	{
		kdLogMessage("slCreateEngine failed");
		return -1;
	}

	// TEhGWIuWFNg̗L?
	result = (*engineObject)->Realize(engineObject, SL_BOOLEAN_FALSE); 
	if(result != SL_RESULT_SUCCESS)
	{
		kdLogMessage("Engine Realize() failed");
		return -1;
	}

	// TEhGW̃C^[tF[X擾
	SLEngineItf engineInterface;
	result = (*engineObject)->GetInterface(engineObject, SL_IID_ENGINE, (void*)&engineInterface);
	if(result != SL_RESULT_SUCCESS)
	{
		kdLogMessage("GetInterface(SL_IID_ENGINE) failed");
		return -1;
	}

	// o̓IuWFNg̍쐬
	SLObjectItf outputMixObject;
	result = (*engineInterface)->CreateOutputMix(engineInterface, &outputMixObject, 0, KD_NULL, KD_NULL);
	if(result != SL_RESULT_SUCCESS)
	{
		kdLogMessage("CreateOutputMix() failed");
		return -1;
	}

	// o̗͂L?
	result = (*outputMixObject)->Realize(outputMixObject, SL_BOOLEAN_FALSE);
	if(result != SL_RESULT_SUCCESS)
	{
		kdLogMessage("OutputMix Realize() failed");
		return -1;
	}

	// L[̃R[obNŎgpf[^
	CallbackContext context;
	context.buffer = reinterpret_cast<char*>(kdMalloc(BUFFER_LENGTH));
	context.nextBlock = 0;


	// t@ĈI[v
	FILE* file = fopen("nc2003.ogg", "rb");
	if(file == NULL)
	{
		kdLogMessage("OutputMix Realize() failed");
		return -1;
	}

	// Ogg vorbist@CƂăI[v
	ov_open(file, &context.oggVorbisFile, 0, 0);

	// t@C̏擾
	vorbis_info* vorbisInfo = ov_info(&context.oggVorbisFile, -1);


	// Đobt@̐ݒ
	SLDataLocator_BufferQueue bufferQueueLocator;
	bufferQueueLocator.locatorType = SL_DATALOCATOR_BUFFERQUEUE;
	bufferQueueLocator.numBuffers  = BUFFER_BLOCK_COUNT;

	// ĐtH[}bg̐ݒ
	SLDataFormat_PCM pcmDataFormat;
	pcmDataFormat.formatType = SL_DATAFORMAT_PCM;
	pcmDataFormat.numChannels = vorbisInfo->channels;
	pcmDataFormat.samplesPerSec = vorbisInfo->rate;
	pcmDataFormat.bitsPerSample = 16;
	pcmDataFormat.containerSize = 16; 
	pcmDataFormat.channelMask = SL_SPEAKER_FRONT_LEFT | SL_SPEAKER_FRONT_RIGHT;
	pcmDataFormat.endianness = SL_BYTEORDER_LITTLEENDIAN;

	// Đobt@ƍĐtH[}bgZbgōĐf[^
	SLDataSource audioSource; 
	audioSource.pFormat  = (void*)&pcmDataFormat;
	audioSource.pLocator = (void*)&bufferQueueLocator;

	// Ԃo͐̐ݒ
	SLDataLocator_OutputMix outputMixLocator;
	outputMixLocator.locatorType = SL_DATALOCATOR_OUTPUTMIX;
	outputMixLocator.outputMix = outputMixObject;

	SLDataSink audioSink;
	audioSink.pLocator = (void *)&outputMixLocator;
	audioSink.pFormat = KD_NULL;


	// vC[IuWFNg쐬
    SLObjectItf playerObject;
	result = (*engineInterface)->CreateAudioPlayer(engineInterface, &playerObject, &audioSource, &audioSink, 0, KD_NULL, KD_NULL); 
	if(result != SL_RESULT_SUCCESS)
	{
		kdLogMessage("CreateAudioPlayer() failed");
		return -1;
	}

	// vC[̗L?
	result = (*playerObject)->Realize(playerObject, SL_BOOLEAN_FALSE);
	if(result != SL_RESULT_SUCCESS)
	{
		kdLogMessage("AudioPlayer Realize() failed");
		return -1;
	}

	// ĐC^[tF[X擾
	SLPlayItf playInterface;
	result = (*playerObject)->GetInterface(playerObject, SL_IID_PLAY, (void**)&playInterface);
	if(result != SL_RESULT_SUCCESS)
	{
		kdLogMessage("GetInterface(SL_IID_PLAY) failed");
		return -1;
	}

	// ĐL[C^[tF[X擾
    SLBufferQueueItf bufferQueueInterface;
	result = (*playerObject)->GetInterface(playerObject, SL_IID_BUFFERQUEUE, (void**)&bufferQueueInterface);
	if(result != SL_RESULT_SUCCESS)
	{
		kdLogMessage("GetInterface(SL_IID_BUFFERQUEUE) failed");
		return -1;
	}

	// ĐL[̃R[obNZbg
	result = (*bufferQueueInterface)->RegisterCallback(bufferQueueInterface, bufferQueueCallback, &context);
	if(result != SL_RESULT_SUCCESS)
	{
		kdLogMessage("BufferQueue RegisterCallbac() failed");
		return -1;
	}

	// obt@Ƀf[^[UčĐL[ɃZbg
	for (int i = 0; i < BUFFER_BLOCK_COUNT - 1; ++i)
		enqueue(bufferQueueInterface, &context);

	// ĐJn
	result = (*playInterface)->SetPlayState(playInterface, SL_PLAYSTATE_PLAYING);
    if(result != SL_RESULT_SUCCESS)
    {
        kdLogMessage("SetPlayState(SL_PLAYSTATE_PLAYING) failed");
		return -1;
    }

	for(;;)
	{
		// Kɑ҂Cxg
		const KDEvent* e = kdWaitEvent(500 * 1000 * 1000LL);
		if(e)
		{
			// ICxĝݏ
            if(e->type == KD_EVENT_QUIT)
                break;

			kdDefaultEvent(e);
		}
    }

	// ĐL[̃NA
	result = (*bufferQueueInterface)->Clear(bufferQueueInterface);
	if(result != SL_RESULT_SUCCESS)
		kdLogMessage("BufferQueue Clear failed");

	// Đ~
	result = (*playInterface)->SetPlayState(playInterface, SL_PLAYSTATE_STOPPED);
    if(result != SL_RESULT_SUCCESS)
        kdLogMessage("SetPlayState(SL_PLAYSTATE_STOPPED) failed");

	// vC[IuWFNg̃NA
	(*playerObject)->Destroy(playerObject);

	// o̓IuWFNg̃NA
	(*outputMixObject)->Destroy(outputMixObject); 

	// TEhGW̃NA
	(*engineObject)->Destroy(engineObject);

	// Đobt@̃NA
	kdFree(context.buffer);

	// Ogg vorbist@C̃N[Y(fcloseōs)
	ov_clear(&context.oggVorbisFile);

	return 0;
}

